diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/ofdm-phy.h ns-3.34/src/wifi/model/non-ht/ofdm-phy.h
--- ns-3.33/src/wifi/model/non-ht/ofdm-phy.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/ofdm-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,443 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Rediet <getachew.redieteab@orange.com>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
+ *          Mathieu Lacage <mathieu.lacage@sophia.inria.fr> (for logic ported from wifi-phy)
+ */
+
+#ifndef OFDM_PHY_H
+#define OFDM_PHY_H
+
+#include "ns3/phy-entity.h"
+
+/**
+ * \file
+ * \ingroup wifi
+ * Declaration of ns3::OfdmPhy class
+ * and ns3::OfdmPhyVariant enum.
+ */
+
+namespace ns3 {
+
+/**
+ * \ingroup wifi
+ * The OFDM (11a) PHY variants.
+ *
+ * \see OfdmPhy
+ */
+enum OfdmPhyVariant
+{
+  OFDM_PHY_DEFAULT,
+  OFDM_PHY_10_MHZ,
+  OFDM_PHY_5_MHZ
+};
+
+/**
+ * \brief PHY entity for OFDM (11a)
+ * \ingroup wifi
+ *
+ * This class is also used for the 10 MHz and 5 MHz bandwidth
+ * variants addressing vehicular communications (default is 20 MHz
+ * bandwidth).
+ *
+ * Refer to IEEE 802.11-2016, clause 17.
+ */
+class OfdmPhy : public PhyEntity
+{
+public:
+  /**
+   * Constructor for OFDM PHY
+   *
+   * \param variant the OFDM PHY variant
+   * \param buildModeList flag used to add OFDM modes to list (disabled
+   *                      by child classes to only add child classes' modes)
+   */
+  OfdmPhy (OfdmPhyVariant variant = OFDM_PHY_DEFAULT, bool buildModeList = true);
+  /**
+   * Destructor for OFDM PHY
+   */
+  virtual ~OfdmPhy ();
+
+  WifiMode GetSigMode (WifiPpduField field, const WifiTxVector& txVector) const override;
+  const PpduFormats & GetPpduFormats (void) const override;
+  Time GetDuration (WifiPpduField field, const WifiTxVector& txVector) const override;
+  Time GetPayloadDuration (uint32_t size, const WifiTxVector& txVector, WifiPhyBand band, MpduType mpdutype,
+                           bool incFlag, uint32_t &totalAmpduSize, double &totalAmpduNumSymbols,
+                           uint16_t staId) const override;
+  Ptr<WifiPpdu> BuildPpdu (const WifiConstPsduMap & psdus, const WifiTxVector& txVector, Time ppduDuration) override;
+
+  /**
+   * Initialize all OFDM modes (for all variants).
+   */
+  static void InitializeModes (void);
+  /**
+   * Return a WifiMode for OFDM
+   * corresponding to the provided rate and
+   * the channel bandwidth (20, 10, or 5 MHz).
+   *
+   * \param rate the rate in bps
+   * \param bw the bandwidth in MHz
+   * \return a WifiMode for OFDM
+   */
+  static WifiMode GetOfdmRate (uint64_t rate, uint16_t bw = 20);
+  /**
+   * Return a WifiMode for OFDM at 6 Mbps.
+   *
+   * \return a WifiMode for OFDM at 6 Mbps
+   */
+  static WifiMode GetOfdmRate6Mbps (void);
+  /**
+   * Return a WifiMode for OFDM at 9 Mbps.
+   *
+   * \return a WifiMode for OFDM at 9 Mbps
+   */
+  static WifiMode GetOfdmRate9Mbps (void);
+  /**
+   * Return a WifiMode for OFDM at 12Mbps.
+   *
+   * \return a WifiMode for OFDM at 12 Mbps
+   */
+  static WifiMode GetOfdmRate12Mbps (void);
+  /**
+   * Return a WifiMode for OFDM at 18 Mbps.
+   *
+   * \return a WifiMode for OFDM at 18 Mbps
+   */
+  static WifiMode GetOfdmRate18Mbps (void);
+  /**
+   * Return a WifiMode for OFDM at 24 Mbps.
+   *
+   * \return a WifiMode for OFDM at 24 Mbps
+   */
+  static WifiMode GetOfdmRate24Mbps (void);
+  /**
+   * Return a WifiMode for OFDM at 36 Mbps.
+   *
+   * \return a WifiMode for OFDM at 36 Mbps
+   */
+  static WifiMode GetOfdmRate36Mbps (void);
+  /**
+   * Return a WifiMode for OFDM at 48 Mbps.
+   *
+   * \return a WifiMode for OFDM at 48 Mbps
+   */
+  static WifiMode GetOfdmRate48Mbps (void);
+  /**
+   * Return a WifiMode for OFDM at 54 Mbps.
+   *
+   * \return a WifiMode for OFDM at 54 Mbps
+   */
+  static WifiMode GetOfdmRate54Mbps (void);
+  /**
+   * Return a WifiMode for OFDM at 3 Mbps with 10 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 3 Mbps with 10 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate3MbpsBW10MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 4.5 Mbps with 10 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 4.5 Mbps with 10 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate4_5MbpsBW10MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 6 Mbps with 10 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 6 Mbps with 10 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate6MbpsBW10MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 9 Mbps with 10 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 9 Mbps with 10 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate9MbpsBW10MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 12 Mbps with 10 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 12 Mbps with 10 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate12MbpsBW10MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 18 Mbps with 10 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 18 Mbps with 10 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate18MbpsBW10MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 24 Mbps with 10 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 24 Mbps with 10 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate24MbpsBW10MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 27 Mbps with 10 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 27 Mbps with 10 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate27MbpsBW10MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 1.5 Mbps with 5 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 1.5 Mbps with 5 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate1_5MbpsBW5MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 2.25 Mbps with 5 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 2.25 Mbps with 5 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate2_25MbpsBW5MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 3 Mbps with 5 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 3 Mbps with 5 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate3MbpsBW5MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 4.5 Mbps with 5 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 4.5 Mbps with 5 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate4_5MbpsBW5MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 6 Mbps with 5 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 6 Mbps with 5 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate6MbpsBW5MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 9 Mbps with 5 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 9 Mbps with 5 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate9MbpsBW5MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 12 Mbps with 5 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 12 Mbps with 5 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate12MbpsBW5MHz (void);
+  /**
+   * Return a WifiMode for OFDM at 13.5 Mbps with 5 MHz channel spacing.
+   *
+   * \return a WifiMode for OFDM at 13.5 Mbps with 5 MHz channel spacing
+   */
+  static WifiMode GetOfdmRate13_5MbpsBW5MHz (void);
+
+  /**
+   * Return the WifiCodeRate from the OFDM mode's unique name using
+   * ModulationLookupTable. This is mainly used as a callback for
+   * WifiMode operation.
+   *
+   * \param name the unique name of the OFDM mode
+   * \return WifiCodeRate corresponding to the unique name
+   */
+  static WifiCodeRate GetCodeRate (const std::string& name);
+  /**
+   * Return the constellation size from the OFDM mode's unique name using
+   * ModulationLookupTable. This is mainly used as a callback for
+   * WifiMode operation.
+   *
+   * \param name the unique name of the OFDM mode
+   * \return constellation size corresponding to the unique name
+   */
+  static uint16_t GetConstellationSize (const std::string& name);
+  /**
+   * Return the PHY rate from the OFDM mode's unique name and
+   * the supplied parameters. This function calls CalculatePhyRate
+   * and is mainly used as a callback for WifiMode operation.
+   *
+   * \param name the unique name of the OFDM mode
+   * \param channelWidth the considered channel width in MHz
+   * \param guardInterval the considered guard interval duration in nanoseconds
+   * \param nss the considered number of streams
+   *
+   * \return the physical bit rate of this signal in bps.
+   */
+  static uint64_t GetPhyRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+
+  /**
+   * Return the PHY rate corresponding to
+   * the supplied TXVECTOR.
+   * This function is mainly used as a callback
+   * for WifiMode operation.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the station ID (only here to have a common signature for all callbacks)
+   * \return the physical bit rate of this signal in bps.
+   */
+  static uint64_t GetPhyRateFromTxVector (const WifiTxVector& txVector, uint16_t staId);
+  /**
+   * Return the data rate corresponding to
+   * the supplied TXVECTOR.
+   * This function is mainly used as a callback
+   * for WifiMode operation.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the station ID (only here to have a common signature for all callbacks)
+   * \return the data bit rate in bps.
+   */
+  static uint64_t GetDataRateFromTxVector (const WifiTxVector& txVector, uint16_t staId);
+  /**
+   * Return the data rate from the OFDM mode's unique name and
+   * the supplied parameters. This function calls CalculateDataRate and
+   * is mainly used as a callback for WifiMode operation.
+   *
+   * \param name the unique name of the OFDM mode
+   * \param channelWidth the considered channel width in MHz
+   * \param guardInterval the considered guard interval duration in nanoseconds
+   * \param nss the considered number of streams
+   *
+   * \return the data bit rate of this signal in bps.
+   */
+  static uint64_t GetDataRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  /**
+   * Check whether the combination of <WifiMode, channel width, NSS> is allowed.
+   * This function is used as a callback for WifiMode operation, and always
+   * returns true since there is no limitation for any mode in OfdmPhy.
+   *
+   * \param channelWidth the considered channel width in MHz
+   * \param nss the considered number of streams
+   * \returns true.
+   */
+  static bool IsModeAllowed (uint16_t channelWidth, uint8_t nss);
+
+protected:
+  PhyFieldRxStatus DoEndReceiveField (WifiPpduField field, Ptr<Event> event) override;
+  Ptr<SpectrumValue> GetTxPowerSpectralDensity (double txPowerW, Ptr<const WifiPpdu> ppdu) const override;
+  uint32_t GetMaxPsduSize (void) const override;
+
+  /**
+   * \param txVector the transmission parameters
+   * \return the WifiMode used for the SIGNAL field
+   */
+  virtual WifiMode GetHeaderMode (const WifiTxVector& txVector) const;
+
+  /**
+   * \param txVector the transmission parameters
+   * \return the duration of the preamble field
+   *
+   * \see WIFI_PPDU_FIELD_PREAMBLE
+   */
+  virtual Time GetPreambleDuration (const WifiTxVector& txVector) const;
+  /**
+   * \param txVector the transmission parameters
+   * \return the duration of the SIGNAL field
+   */
+  virtual Time GetHeaderDuration (const WifiTxVector& txVector) const;
+
+  /**
+   * \return the number of service bits
+   */
+  uint8_t GetNumberServiceBits (void) const;
+  /**
+   * \param band the frequency band being used
+   * \return the signal extension duration
+   */
+  Time GetSignalExtension (WifiPhyBand band) const;
+
+  /**
+   * End receiving the header, perform OFDM-specific actions, and
+   * provide the status of the reception.
+   *
+   * \param event the event holding incoming PPDU's information
+   * \return status of the reception of the header
+   */
+  PhyFieldRxStatus EndReceiveHeader (Ptr<Event> event);
+
+  /**
+   * Checks if the PPDU's bandwidth is supported by the PHY.
+   *
+   * \param ppdu the received PPDU
+   * \return \c true if supported, \c false otherwise
+   */
+  virtual bool IsChannelWidthSupported (Ptr<const WifiPpdu> ppdu) const;
+  /**
+   * Checks if the signaled configuration (including bandwidth)
+   * is supported by the PHY.
+   *
+   * \param field the current PPDU field (SIG used for checking config)
+   * \param ppdu the received PPDU
+   * \return \c true if supported, \c false otherwise
+   */
+  virtual bool IsAllConfigSupported (WifiPpduField field, Ptr<const WifiPpdu> ppdu) const;
+
+  /**
+   * Calculate the PHY rate in bps from code rate and data rate.
+   *
+   * \param codeRate the WifiCodeRate
+   * \param dataRate the data rate in bps
+   * \return the physical rate in bps from WifiCodeRate and data rate.
+   */
+  static uint64_t CalculatePhyRate (WifiCodeRate codeRate, uint64_t dataRate);
+  /**
+   * Convert WifiCodeRate to a ratio, e.g., code ratio of WIFI_CODE_RATE_1_2 is 0.5.
+   *
+   * \param codeRate the WifiCodeRate
+   * \return the ratio form of WifiCodeRate.
+   */
+  static double GetCodeRatio (WifiCodeRate codeRate);
+  /**
+   * Calculates data rate from the supplied parameters.
+   *
+   * \param codeRate the code rate of the mode
+   * \param constellationSize the size of modulation constellation
+   * \param channelWidth the considered channel width in MHz
+   * \param guardInterval the considered guard interval duration in nanoseconds
+   * \param nss the considered number of streams
+   *
+   * \return the data bit rate of this signal in bps.
+   */
+  static uint64_t CalculateDataRate (WifiCodeRate codeRate, uint16_t constellationSize, uint16_t channelWidth,
+                                     uint16_t guardInterval, uint8_t nss);
+  /**
+   * Calculates data rate from the supplied parameters.
+   *
+   * \param symbolDuration the symbol duration (in us) excluding guard interval
+   * \param guardInterval the considered guard interval duration in nanoseconds
+   * \param usableSubCarriers the number of usable subcarriers for data
+   * \param numberOfBitsPerSubcarrier the number of data bits per subcarrier
+   * \param codingRate the coding rate
+   *
+   * \return the data bit rate of this signal in bps.
+   */
+  static uint64_t CalculateDataRate (double symbolDuration, uint16_t guardInterval,
+                                     uint16_t usableSubCarriers, uint16_t numberOfBitsPerSubcarrier,
+                                     double codingRate);
+
+private:
+  /**
+   * Create an OFDM mode from a unique name, the unique name
+   * must already be contained inside ModulationLookupTable.
+   * This method binds all the callbacks used by WifiMode.
+   *
+   * \param uniqueName the unique name of the WifiMode
+   * \param isMandatory whether the WifiMode is mandatory
+   * \return the OFDM WifiMode
+   */
+  static WifiMode CreateOfdmMode (std::string uniqueName, bool isMandatory);
+
+  static const PpduFormats m_ofdmPpduFormats; //!< OFDM PPDU formats
+
+  static const ModulationLookupTable m_ofdmModulationLookupTable; //!< lookup table to retrieve code rate and constellation size corresponding to a unique name of modulation
+}; //class OfdmPhy
+
+} //namespace ns3
+
+#endif /* OFDM_PHY_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/ofdm-ppdu.cc ns-3.34/src/wifi/model/non-ht/ofdm-ppdu.cc
--- ns-3.33/src/wifi/model/non-ht/ofdm-ppdu.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/ofdm-ppdu.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,259 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Rediet <getachew.redieteab@orange.com>
+ *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
+ *         Sébastien Deronne <sebastien.deronne@gmail.com> (LSigHeader)
+ */
+
+#include "ns3/wifi-phy.h"
+#include "ns3/wifi-psdu.h"
+#include "ofdm-phy.h"
+#include "ofdm-ppdu.h"
+#include "ns3/log.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("OfdmPpdu");
+
+OfdmPpdu::OfdmPpdu (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector,
+                    WifiPhyBand band, uint64_t uid,
+                    bool instantiateLSig /* = true */)
+  : WifiPpdu (psdu, txVector, uid),
+    m_band (band),
+    m_channelWidth (txVector.GetChannelWidth ())
+{
+  NS_LOG_FUNCTION (this << psdu << txVector << band << uid);
+  if (instantiateLSig)
+    {
+      m_lSig.SetRate (txVector.GetMode ().GetDataRate (txVector), m_channelWidth);
+      m_lSig.SetLength (psdu->GetSize ());
+    }
+}
+
+OfdmPpdu::~OfdmPpdu ()
+{
+}
+
+WifiTxVector
+OfdmPpdu::DoGetTxVector (void) const
+{
+  WifiTxVector txVector;
+  txVector.SetPreambleType (m_preamble);
+  //OFDM uses 20 MHz, unless PHY channel width is 5 MHz or 10 MHz
+  uint16_t channelWidth = m_channelWidth < 20 ? m_channelWidth : 20;
+  txVector.SetMode (OfdmPhy::GetOfdmRate (m_lSig.GetRate (m_channelWidth), channelWidth));
+  txVector.SetChannelWidth (channelWidth);
+  return txVector;
+}
+
+Time
+OfdmPpdu::GetTxDuration (void) const
+{
+  Time ppduDuration = Seconds (0);
+  const WifiTxVector& txVector = GetTxVector ();
+  ppduDuration = WifiPhy::CalculateTxDuration (m_lSig.GetLength (), txVector, m_band);
+  return ppduDuration;
+}
+
+Ptr<WifiPpdu>
+OfdmPpdu::Copy (void) const
+{
+  return Create<OfdmPpdu> (GetPsdu (), GetTxVector (), m_band, m_uid);
+}
+
+OfdmPpdu::LSigHeader::LSigHeader ()
+  : m_rate (0b1101),
+    m_length (0)
+{
+}
+
+OfdmPpdu::LSigHeader::~LSigHeader ()
+{
+}
+
+TypeId
+OfdmPpdu::LSigHeader::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::LSigHeader")
+    .SetParent<Header> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<LSigHeader> ()
+  ;
+  return tid;
+}
+
+TypeId
+OfdmPpdu::LSigHeader::GetInstanceTypeId (void) const
+{
+  return GetTypeId ();
+}
+
+void
+OfdmPpdu::LSigHeader::Print (std::ostream &os) const
+{
+  os << "SIGNAL=" << GetRate ()
+     << " LENGTH=" << m_length;
+}
+
+uint32_t
+OfdmPpdu::LSigHeader::GetSerializedSize (void) const
+{
+  return 3;
+}
+
+void
+OfdmPpdu::LSigHeader::SetRate (uint64_t rate, uint16_t channelWidth)
+{
+  if (channelWidth == 5)
+    {
+      rate *= 4; //corresponding 20 MHz rate if 5 MHz is used
+    }
+  else if (channelWidth == 10)
+    {
+      rate *= 2; //corresponding 20 MHz rate if 10 MHz is used
+    }
+  /* Here is the binary representation for a given rate:
+   * 6 Mbit/s: 1101
+   * 9 Mbit/s: 1111
+   * 12 Mbit/s: 0101
+   * 18 Mbit/s: 0111
+   * 24 Mbit/s: 1001
+   * 36 Mbit/s: 1011
+   * 48 Mbit/s: 0001
+   * 54 Mbit/s: 0011
+   */
+  switch (rate)
+    {
+      case 6000000:
+        m_rate = 0b1101;
+        break;
+      case 9000000:
+        m_rate = 0b1111;
+        break;
+      case 12000000:
+        m_rate = 0b0101;
+        break;
+      case 18000000:
+        m_rate = 0b0111;
+        break;
+      case 24000000:
+        m_rate = 0b1001;
+        break;
+      case 36000000:
+        m_rate = 0b1011;
+        break;
+      case 48000000:
+        m_rate = 0b0001;
+        break;
+      case 54000000:
+        m_rate = 0b0011;
+        break;
+      default:
+        NS_ASSERT_MSG (false, "Invalid rate");
+        break;
+    }
+}
+
+uint64_t
+OfdmPpdu::LSigHeader::GetRate (uint16_t channelWidth) const
+{
+  uint64_t rate = 0;
+  switch (m_rate)
+    {
+      case 0b1101:
+        rate = 6000000;
+        break;
+      case 0b1111:
+        rate = 9000000;
+        break;
+      case 0b0101:
+        rate = 12000000;
+        break;
+      case 0b0111:
+        rate = 18000000;
+        break;
+      case 0b1001:
+        rate = 24000000;
+        break;
+      case 0b1011:
+        rate = 36000000;
+        break;
+      case 0b0001:
+        rate = 48000000;
+        break;
+      case 0b0011:
+        rate = 54000000;
+        break;
+      default:
+        NS_ASSERT_MSG (false, "Invalid rate");
+        break;
+    }
+  if (channelWidth == 5)
+    {
+      rate /= 4; //compute corresponding 5 MHz rate
+    }
+  else if (channelWidth == 10)
+    {
+      rate /= 2; //compute corresponding 10 MHz rate
+    }
+  return rate;
+}
+
+void
+OfdmPpdu::LSigHeader::SetLength (uint16_t length)
+{
+  NS_ASSERT_MSG (length < 4096, "Invalid length");
+  m_length = length;
+}
+
+uint16_t
+OfdmPpdu::LSigHeader::GetLength (void) const
+{
+  return m_length;
+}
+
+void
+OfdmPpdu::LSigHeader::Serialize (Buffer::Iterator start) const
+{
+  uint8_t byte = 0;
+  uint16_t bytes = 0;
+
+  byte |= m_rate;
+  byte |= (m_length & 0x07) << 5;
+  start.WriteU8 (byte);
+
+  bytes |= (m_length & 0x0ff8) >> 3;
+  start.WriteU16 (bytes);
+}
+
+uint32_t
+OfdmPpdu::LSigHeader::Deserialize (Buffer::Iterator start)
+{
+  Buffer::Iterator i = start;
+
+  uint8_t byte = i.ReadU8 ();
+  m_rate = byte & 0x0f;
+  m_length = (byte >> 5) & 0x07;
+
+  uint16_t bytes = i.ReadU16 ();
+  m_length |= (bytes << 3) & 0x0ff8;
+
+  return i.GetDistanceFrom (start);
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/ofdm-ppdu.h ns-3.34/src/wifi/model/non-ht/ofdm-ppdu.h
--- ns-3.33/src/wifi/model/non-ht/ofdm-ppdu.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/ofdm-ppdu.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,136 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Rediet <getachew.redieteab@orange.com>
+ *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
+ *         Sébastien Deronne <sebastien.deronne@gmail.com> (LSigHeader)
+ */
+
+#ifndef OFDM_PPDU_H
+#define OFDM_PPDU_H
+
+#include "ns3/wifi-phy-band.h"
+#include "ns3/wifi-ppdu.h"
+#include "ns3/header.h"
+
+/**
+ * \file
+ * \ingroup wifi
+ * Declaration of ns3::OfdmPpdu class.
+ */
+
+namespace ns3 {
+
+class WifiPsdu;
+
+/**
+ * \brief OFDM PPDU (11a)
+ * \ingroup wifi
+ *
+ * OfdmPpdu stores a preamble, PHY headers and a PSDU of a PPDU with non-HT header,
+ * i.e., PPDU that uses OFDM modulation.
+ */
+class OfdmPpdu : public WifiPpdu
+{
+public:
+
+  /**
+   * OFDM and ERP OFDM L-SIG PHY header.
+   * See section 17.3.4 in IEEE 802.11-2016.
+   */
+  class LSigHeader : public Header
+  {
+  public:
+    LSigHeader ();
+    virtual ~LSigHeader ();
+
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId (void);
+
+    TypeId GetInstanceTypeId (void) const override;
+    void Print (std::ostream &os) const override;
+    uint32_t GetSerializedSize (void) const override;
+    void Serialize (Buffer::Iterator start) const override;
+    uint32_t Deserialize (Buffer::Iterator start) override;
+
+    /**
+     * Fill the RATE field of L-SIG (in bit/s).
+     *
+     * \param rate the RATE field of L-SIG expressed in bit/s
+     * \param channelWidth the channel width (in MHz)
+     */
+    void SetRate (uint64_t rate, uint16_t channelWidth = 20);
+    /**
+     * Return the RATE field of L-SIG (in bit/s).
+     *
+     * \param channelWidth the channel width (in MHz)
+     * \return the RATE field of L-SIG expressed in bit/s
+     */
+    uint64_t GetRate (uint16_t channelWidth = 20) const;
+    /**
+     * Fill the LENGTH field of L-SIG (in bytes).
+     *
+     * \param length the LENGTH field of L-SIG expressed in bytes
+     */
+    void SetLength (uint16_t length);
+    /**
+     * Return the LENGTH field of L-SIG (in bytes).
+     *
+     * \return the LENGTH field of L-SIG expressed in bytes
+     */
+    uint16_t GetLength (void) const;
+
+  private:
+    uint8_t m_rate;    ///< RATE field
+    uint16_t m_length; ///< LENGTH field
+  }; //class LSigHeader
+
+  /**
+   * Create an OFDM PPDU.
+   *
+   * \param psdu the PHY payload (PSDU)
+   * \param txVector the TXVECTOR that was used for this PPDU
+   * \param band the WifiPhyBand used for the transmission of this PPDU
+   * \param uid the unique ID of this PPDU
+   * \param instantiateLSig flag used to instantiate LSigHeader (set LSigHeader's
+   *                        rate and length), should be disabled by child classes
+   */
+  OfdmPpdu (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, WifiPhyBand band, uint64_t uid,
+            bool instantiateLSig = true);
+  /**
+   * Destructor for OfdmPpdu.
+   */
+  virtual ~OfdmPpdu ();
+
+  Time GetTxDuration (void) const override;
+  Ptr<WifiPpdu> Copy (void) const override;
+
+protected:
+  WifiPhyBand m_band;       //!< the WifiPhyBand used to transmit that PPDU
+  uint16_t m_channelWidth;  //!< the channel width used to transmit that PPDU in MHz
+  LSigHeader m_lSig;        //!< the L-SIG PHY header
+
+private:
+  WifiTxVector DoGetTxVector (void) const override;
+}; //class OfdmPpdu
+
+} //namespace ns3
+
+#endif /* OFDM_PPDU_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/originator-block-ack-agreement.cc ns-3.34/src/wifi/model/originator-block-ack-agreement.cc
--- ns-3.33/src/wifi/model/originator-block-ack-agreement.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/originator-block-ack-agreement.cc	2021-07-14 10:31:07.000000000 -0700
@@ -88,8 +88,7 @@
 std::size_t
 OriginatorBlockAckAgreement::GetDistance (uint16_t seqNumber) const
 {
-  NS_ASSERT (seqNumber < SEQNO_SPACE_SIZE);
-  return (seqNumber - GetStartingSequence () + SEQNO_SPACE_SIZE) % SEQNO_SPACE_SIZE;
+  return BlockAckAgreement::GetDistance (seqNumber, m_txWindow.GetWinStart ());
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/originator-block-ack-agreement.h ns-3.34/src/wifi/model/originator-block-ack-agreement.h
--- ns-3.33/src/wifi/model/originator-block-ack-agreement.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/originator-block-ack-agreement.h	2021-07-14 10:31:07.000000000 -0700
@@ -155,7 +155,7 @@
    *
    * \return the starting sequence number.
    */
-  uint16_t GetStartingSequence (void) const;
+  uint16_t GetStartingSequence (void) const override;
 
   /**
    * Get the distance between the current starting sequence number and the
